import java.util.*;

public class SolarFarm_AN {
    static long r, w, h;

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        int t = s.nextInt();
        for (int tc = 0; tc < t; tc++) {
            r = s.nextLong();
            w = s.nextLong();
            h = s.nextLong();
            if (w < h) {
                long swap = w; w = h; h = swap;
            }
            if (w * w + h * h > 4 * r * r) {
                System.out.println(0);
                continue;
            }

            long center = bestNonInt(1, 2 * r / w);
            long cx2 = 4 * r * r - center * center * w * w;
            long centerHeight = safeSqrt(cx2 / (h * h));

            long lo = bSearchLo(1, center, center * centerHeight * w * h);
            long hi = bSearchHi(center, 2 * r / w, center * centerHeight * w * h);
            long best = center * centerHeight;
            for (long i = lo; i <= hi; i++) {
                long x2 = 4 * r * r - i * i * w * w;
                long j = safeSqrt(x2 / (h * h));
                if (i * j > best) {
                    best = i * j;
                }
            }
            System.out.println(best);
    
        }
    }

    static long safeSqrt(long n) {
        long ans = Math.round(Math.floor(Math.sqrt(n)));
        while (ans * ans > n) ans--;
        return ans;
    }

    static long bestNonInt(long lo, long hi) {
        if (lo == hi) return lo;
        if (lo + 1 == hi) {
            if (area(lo) < area(hi)) {
                return hi;
            } else {
                return lo;
            }
        }
        long l3 = Math.round((2.0 * lo + hi) / 3);
        long h3 = Math.round((lo + 2.0 * hi) / 3);
        if (area(l3) < area(h3)) {
            return bestNonInt(l3, hi);
        } else {
            return bestNonInt(lo, h3);
        }
    }

    static double area(long n) {
        return Math.sqrt(4 * r * r - n * n * w * w) * n * w;
    }

    static long bSearchLo(long lo, long hi, long limit) {
        if (lo + 1 >= hi) {
            if (area(hi) <= limit) return hi;
            return lo;
        }
        long mid = (lo + hi) / 2;
        if (area(mid) <= limit) {
            return bSearchLo(mid, hi, limit);
        } else {
            return bSearchLo(lo, mid, limit);
        }
    }

    static long bSearchHi(long lo, long hi, long limit) {
        if (lo + 1 >= hi) {
            if (area(lo) <= limit) return lo;
            return hi;
        }
        long mid = (lo + hi) / 2;
        if (area(mid) <= limit) {
            return bSearchHi(lo, mid, limit);
        } else {
            return bSearchHi(mid, hi, limit);
        }
    }
}
