#include <iostream>
#include <cmath>
#include <cstdint>

uint64_t isqrt(uint64_t n)
{
  uint64_t lo = 0;
  uint64_t hi = (1ULL<<32ULL) - 1ULL;
  if(hi*hi < n)
    return hi;
  while(hi-lo > 1)
    {
      int64_t mid = lo + (hi-lo)/2;
      if(mid*mid <= n)
	{
	  lo = mid;
	}
      else
	{
	  hi = mid;
	}
    }
  return lo;
}

void doCase()
{
  int64_t r, w, h;
  std::cin >> r >> w >> h;
  if(w < h)
    std::swap(w,h);
  int64_t xc = std::sqrt(2.0) * double(r) / double(w);
  int64_t eps = std::pow(128.0, 0.25) * std::sqrt(double(r)/double(w));
  int64_t best = 0;
  int64_t lb = std::max(int64_t(0), xc-eps);
  int64_t ub = std::min( (2*r)/w, xc+eps);
  for(int64_t x = lb; x <= ub; x++)
    {
      int64_t y = isqrt(4 * r * r - x * x * w * w) / h;
      if(x*y > best)
	best = x*y;
    }
  std::cout << best << std::endl;
}

int main()
{
  int t;
  std::cin >> t;
  for(int i=0; i<t; i++)
    {
      doCase();
    }
}
