#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <chrono>
#include <cmath>
#include <cstdint>
#include <cstring>
#include <functional>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <unordered_set>
#include <utility>
#include <vector>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define smx(a, b) a = max(a, b)
#define smn(a, b) a = min(a, b)
#define pb push_back
#define endl '\n'

const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

mt19937 rng(time(0));

int main() {
	cin.tie(0)->sync_with_stdio(0);

	int t; cin >> t;
	while (t--) {
		ll r, w, h; cin >> r >> w >> h;
		if (w < h) swap(w, h);
		if (w * w + h * h > 4 * r * r) {
			cout << "0\n";
			continue;
		}
		ll ans = 0;
		ll cent = (ll)((ld)1.0 * r * sqrtl(2));
		cent /= w;
		for (ll cand_w = max(1ll, cent - 30000); cand_w <= cent + 30000; cand_w++) {
			if (cand_w * w >= 2 * r) break;
			if (cand_w * w * cand_w * w + h * h > 4 * r * r) break;
			// can fit sqrt(4r^2 - (cand_w * w * cand_w * cand_w)) / h many
			ll cand_h = llround(sqrt(4 * r * r - (cand_w * w * cand_w * w))) / h + 1;
			while (cand_w * cand_w * w * w + h * cand_h * h * cand_h > 4 * r * r) --cand_h;
			ans = max(ans, cand_w * cand_h);
		}
		cout << ans << "\n";
	}

}
